#include <cstdlib>
#include <conio.h>
#include <cstdio>
#include <cstring>

using namespace std;

int main(void)
{   
    char arquivo_script[256];
    char arquivo_iso[256];
    
    printf("Script file: ");
    gets(arquivo_script);
    printf("ISO file: ");
    gets(arquivo_iso);
    printf("\nProceed? (Y or N): ");
    
    char temp = getch();
    if((temp != 'y') && (temp !='Y')){
             printf("\nAborted by user.");
             getch();
             exit(EXIT_SUCCESS);
    }

    printf("\n\n");
    
    FILE *script = fopen(arquivo_script,"r");
    if(!script){
                printf("Error opening script file.");
                exit(EXIT_FAILURE);
    }
    FILE *iso = fopen(arquivo_iso,"r+b");
    if(!iso){
                printf("Error opening ISO file.");
                exit(EXIT_FAILURE);
    }
    
    printf("Alocando 64mb... ");
    unsigned char *buffer = (unsigned char *)malloc(67108864);
    if(!buffer){
                printf("FAIL!");
                exit(EXIT_FAILURE);
    }
    printf("OK!\n");
    printf("Copying ISO to memory... ");
    size_t temp2 = fread(buffer,1,67108864,iso);
    if(temp2 != 67108864){
             printf("FAIL? End of file reached?");
             exit(EXIT_FAILURE);
    }
    printf("OK!\n");
    
    char nome_antigo[256];
    char nome_novo[256];
    
    printf("Starting replacing...\n");
    
    int i, tamanho_nome, retorno;
    bool substituido;
    
    while(!feof(script)){
         fscanf(script,"%s\n",nome_antigo);
         fscanf(script,"%s\n",nome_novo);
         tamanho_nome = strlen(nome_antigo);
         printf("%s -> %s\n... ",nome_antigo,nome_novo);
         substituido = false;
         //Little less than 64mb
         for(i=0; i < 67000000; i++){
                  retorno = memcmp(&buffer[i],nome_antigo,tamanho_nome);
                  if(!retorno){
                              substituido = true;
                              memcpy(&buffer[i],nome_novo,tamanho_nome);
                              break;
                  }
         }
         if(!substituido){
                  printf("String not found! Abort? (Y or N): ");
                  temp = getch();
                  if((temp != 'n') && (temp != 'N')){
                           printf("\nAborted by user.");
                           exit(EXIT_SUCCESS);
                  }         
         }
         else printf("OK!\n");
    }
    
    printf("\nWriting buffer back at the file... ");
    fseek(iso, 0, SEEK_SET);
    temp2 = fwrite(buffer, 1, 67108864, iso);
    if(temp2 != 67108864){
             printf("Error! Aborting...");
             exit(EXIT_FAILURE);
    }
    printf("OK!\nIt should be done.");
}
